#!/usr/bin/env python3
#
# An HTTP server that returns fewer bytes in the body of the response than
# stated in the chunk size when using "Transfer-Encoding: Chunked".
#

import socketserver

MESSAGE = (
    b'HTTP/1.1 200 OK\r\n'
    b'Transfer-Encoding: chunked\r\n'
    b'Content-Type: text/plain\r\n'
    b'Access-Control-Allow-Origin: *\r\n'
    b'\r\n'
    b'7\r\n'
    b'Mozilla\r\n'
)

TERMINATOR = b'0\r\n\r\n'

class MyTCPHandler(socketserver.BaseRequestHandler):
    def handle(self):
        data = self.request.recv(1024)
        decoded = data.decode()
        print(decoded)
        if ("foobar" in decoded):
            message = MESSAGE
        else:
            message = MESSAGE + TERMINATOR
        self.request.sendall(message)

class MyTCPSever(socketserver.TCPServer):
    allow_reuse_address = True

server = MyTCPSever(('localhost', 8080), MyTCPHandler)
server.serve_forever()
